from PListParser import *
from qt import *
from qtxml import *
#from kdecore import *
#from kfile import *
##~ from kdefx import *

from utils import *
from importsession import *
from importthread import *

#import _kdesip

import sys
import os, errno
import shutil
import copy
import time
import cPickle


class LPhotoLibrary(QObject):
	strLatestRoll = "Latest Import"
	strMasterAlbum = "Photo Library"
	strTrash = "Trash"

	def class_libraryPath(self):
		return str(os.path.join(os.path.expanduser('~'),'My Documents','My Photos','Lphoto Library'))
	libraryPath = classmethod(class_libraryPath)

	def __init__(self, app):
		QObject.__init__(self)
		self.app = app
		self.rootPList = None
		self.readLibrary()
		if not(self.rootPList):
			self.newLibrary()

	def __del__(self):
		print "write library!!!!"
		self.writeLibrary()

	def readLibrary(self):
		# open XML file
		print "Reading Library"
		filename = os.path.join(self.libraryPath(), "AlbumData.bin")
		importDestPath = self.libraryPath()
		LUtils.ensureDirectory(importDestPath)
		if LUtils.fileExists(filename):
			try:
				inf = open(filename, mode="rb")
				self.rootPList = cPickle.load(inf)
				inf.close()
			except EOFError, IOError:
				return
		if self.rootPList:
			return

		try:
			filename = os.path.join(self.libraryPath(), "AlbumData.xml")
			reader = PListReader()
			self.rootPList = reader.parse(filename)
		except IOError:
			return
			
	def fastWrite(self):
		filename = os.path.join(self.libraryPath(), "AlbumData.bin")
		ouf = open(filename, mode="wb")
		cPickle.dump(self.rootPList, ouf, 1)
		ouf.close()

	def writeLibrary(self):
		self.fastWrite()
		filename = os.path.join(self.libraryPath(), "AlbumData.xml")
		writer = PListWriter()
		writer.unparse(self.rootPList, filename)

	def newLibrary(self):
		print "Creating Default Empty Library"
		self.rootPList = [{'List of Albums':[],'Master Image List':{},'TrashExtraInfo':{},'Major Version':1,'Minor Version':0,'Application Version':'1.0','Archive Path':str(self.libraryPath())}]
		album = self.__newAlbumFromPath([self.strMasterAlbum])
		album['Master'] = True
		album['Type'] = "Master"
		album['W'] = False
		album = self.__newAlbumFromPath([self.strLatestRoll])
		album['Type']="Roll"
		album['W'] = False
		album = self.__newAlbumFromPath([self.strTrash])
		album['Type']=self.strTrash
		album['Trash'] = True
		album['W'] = False

 	def getMasterImageList(self):
 		return self.rootPList[0]['Master Image List']

	def getAlbumList(self):
		return self.rootPList[0]['List of Albums']

	def getTrashExtraInfo(self):
		return self.rootPList[0]['TrashExtraInfo']
		
	def __newAlbumFromPath(self, path):
		albums = self.rootPList[0]['List of Albums']
		i = 0
		found = True
		while found and i < len(path):
			found = False
			for album in albums:
				if album['AlbumName'] == path[i]:
					if i == len(path)-1:
						return album
					else:
						i = i + 1
						albums = album['AlbumList']
						found = True

		#album was not found, create in albums
		for j in xrange(i, len(path)):
			album = self.__newAlbum(path[j])
			albums.append(album)
			albums = album['AlbumList']
		return album

	def __newAlbum(self, name, keys=[]):
		album = {}
		album['AlbumName'] = name
		album['RepeatSlideShow'] = False
		album['SecondsPerSlide'] = 5
		album['KeyList'] = copy.copy(keys)
		album['AlbumList'] = []
		album['W']=True
		album['Sort']="Date"
		album['Type']="normal"
		print "library new album"
		#create filesystem folder
		return album

	def slotNewAlbum(self):
		album = self.__newAlbum(self.__getNewAlbumName(), [])
		self.rootPList[0]['List of Albums'].append(album)
		self.emit(PYSIGNAL("newAlbum"),(album['AlbumName'], None))

	def slotNewAlbumWithKeys(self, keys):
		album = self.__newAlbum(self.__getNewAlbumName(), keys)
		self.rootPList[0]['List of Albums'].append(album)
		self.emit(PYSIGNAL("newAlbum"),(album['AlbumName'], None))
		
	def __getNewKey(self, key):
		base = key
		i = 1
		while (self.getImage(key)):
			key = base + str(i)
			print "Key conflict, generating new key",key
			i = i + 1
		return key

	def __getNewAlbumName(self):
		i = 1
		while True:
			name = "Album " + str(i)
			if not(self.getAlbum([name])):
				return name
			i = i + 1

	def getAlbum(self, path):
		print "getAlbum",path,type(path)
		albums = self.rootPList[0]['List of Albums']
		i = 0
		found = True
		while found and i < len(path):
			found = False
			for album in albums:
				if album['AlbumName'] == path[i]:
					if i == len(path)-1:
						return album
					else:
						i = i + 1
						albums = album['AlbumList']
						found = True
		
		# if we got here, no match found
		return None

	def getImage(self, key):
		return self.rootPList[0]['Master Image List'].get(key, None)
		
	def __refreshThumbnail(self, dict):
		(w,h) = LUtils.downsizeImage(dict['ImagePath'], dict['ThumbPath'])
		dict['Width'] = w
		dict['Height'] = h
		dict['AspectRatio'] = w/float(h)

	def slotAddPhotosToAlbum(self, path, keys, srcPath):
		print "addPhotosToAlbum",path,keys
		album = self.getAlbum(path)
		srcAlbum = self.getAlbum(srcPath)
		if album:
			if srcAlbum['Type'] == self.strTrash:
				# move image out of trash
				masterAlbum = self.getAlbum([self.strMasterAlbum])
				for key in keys:
					masterAlbum['KeyList'].append(key)
				if album['Type'] != "Master":
					for key in keys:
						album['KeyList'].append(key)
				self.trashKeyListFromAlbum(srcAlbum, keys)
				self.emit(PYSIGNAL("updateAlbums"),([path,srcPath],None))
			else:
				for key in keys:
					album['KeyList'].append(key)
					self.emit(PYSIGNAL("updateAlbums"),([path],None))
				# if album is 'normal' create filesystem links here

	def trashKeyList(self, path, keys):
		print "Library trash keys path",path,"keys",keys
		# normal album -> trash, just remove those images from the album.  The images do not go into the trash unless they are deleted from the MasterList
		album = self.getAlbum(path)
		if album:
			if album['Type']=="Master": #move keys from master list to trash list
				self.trashKeyListFromMaster(album, keys)
			else: # remove keys from this album only
				self.trashKeyListFromAlbum(album, keys)
				self.emit(PYSIGNAL("updateAlbums"),([path],None))
		else:
			print "trash key files",keys,"in",path
		self.fastWrite()

	def trashKeyListFromAlbum(self, album, keys):
		print "delete",keys,"from",album['AlbumName']
		albumKeys = album['KeyList']
		print albumKeys
		for key in keys:
			print "key",key,":",albumKeys
			if key in albumKeys:
				albumKeys.remove(key)
				# remove filesystem links here

	def trashKeyListFromMaster(self, masterAlbum, keys):
		print "delete from master album"
		albumPaths = self.__albumPathsFromKeys(keys)
		albumKeys = masterAlbum['KeyList']
		# verify with user

		# add key to trash with album list
		print "Add",keys,"to Trash"
		for key in keys:
			albumPaths = self.__albumPathsFromKeys([key])
			self.trashAddImageWithAlbums(key,albumPaths)

		# delete keys from each album
		print "Deleting",keys,"in",albumPaths
		for path in albumPaths:
			self.trashKeyListFromAlbum(self.getAlbum(path), keys)

		#more effcient way to do this... I'm sure
		self.emit(PYSIGNAL("updateAlbums"),(albumPaths, None))
		
	def removeAlbum(self, path):
		albums = self.rootPList[0]['List of Albums']
		i = 0
		while i<len(path):
			name = path[i]
			for album in albums:
				if album['AlbumName'] == name:
					if i == len(path)-1:
						albums.remove(album)
						# remove filesystem folder
						return album
					else:
						albums = album['AlbumList']
						break
			i = i + 1

	def trashAlbum(self, path):
		album = self.removeAlbum(path)
		if album:
			self.emit(PYSIGNAL("delAlbum"),(path, None))

	def renameAlbum(self, path, newName):
		album = self.getAlbum(path)
		if album:
			album['AlbumName'] = str(newName)
			print "Album " + str(path) + " -> " + str(newName)
			# rename filesystem folder
			
	def __albumPathsFromKeysRecurse(self, keys, albums, list, path):
		for album in albums:
			albumKeys = album['KeyList']
			childPath = path + [album['AlbumName']]
			for key in albumKeys:
				if key in keys:
					print "adding album",childPath
					list.append(childPath)
					break
			self.__albumPathsFromKeysRecurse(keys,album['AlbumList'],list,childPath)

	def __albumPathsFromKeys(self, keys):#make recursive
		list = []
		albums = self.rootPList[0]['List of Albums']
		self.__albumPathsFromKeysRecurse(keys, albums, list, [])
		self.fastWrite()
		return list

	def trashAddImageWithAlbums(self, key, albums): # when an image is deleted, the locations it was removed from are saved
		self.getTrashExtraInfo()[key] = albums
		self.getAlbum([self.strTrash])['KeyList'].append(key)

	def trashRestoreImage(self, key):
		print "Restore from Trash" # add key back to any albums it came from
		albumNames = self.getTraskExtraInfo()[key]
		for albumName in albumNames:
			self.slotAddPhotosToAlbum(albumName, [key])
		self.trashKeyListFromAlbum(self.getAlbum([self.strTrash]), [key])
		
	def trashEmptyTrash(self):
		wc = LWaitCursor()
		keys = 	self.getAlbum([self.strTrash])['KeyList']
		mil = self.rootPList[0]['Master Image List']
		while len(keys):
			dict = self.getImage(keys[0])
			if dict:
				(dir, filename) = os.path.split(dict['ImagePath'])
				bdir = os.path.join(dir,"originals")
				bpath = os.path.join(bdir, filename)
				LUtils.removeFile(bpath)
				LUtils.removeFile(dict['ImagePath'])
				LUtils.removeFile(dict['ThumbPath'])
				#remove from master image list
				del mil[keys[0]]
			del keys[0]
		self.emit(PYSIGNAL("updateAlbums"),([[self.strTrash]], None))
			

	def trashDeleteImagePerm(self, key):
		print "Remove from trash"
		# verify with user
		# remove from trash
		
		# remove from Master Image List
		# delete file and thumbnail, if last file in directory, remove directory

	def setImageCaption(self, key, caption):
		print "Setting Image Caption",key,":",caption
		p = self.getImage(key)
		print "Old Caption",p['Caption']
		if p:
			p['Caption'] = str(caption)
			self.emit(PYSIGNAL("setCaption"),(key,None))

	def setImageDate(self, key, date):
		# this should update the auto date albums
		p = self.getImage(key)
		if p:
			p['Date'] = date
			
	def setImageRating(self, key, rating):
		p = self.getImage(key)
		if p and p['Rating'] != int(rating):
			p['Rating'] = int(rating)
			self.emit(PYSIGNAL("setRating"),(key,None))
			
	def setImageComment(self, key, comment):
		p = self.getImage(key)
		if p:
			p['Comments']=str(comment)
			
	def __printAlbumDebug(self, list=None, level=0):
		if not list:
			list = self.rootPList[0]['List of Albums']
		for album in list:
			s = " " * level
			print s, album['AlbumName']
			albums = album['AlbumList']
			if albums:
				self.__printAlbumDebug(albums, level+1)

	def __addPhotoToAlbums(self, key, dict, albumPath):
		albums = []
		# add to and main library
		mil = self.getMasterImageList()
		mil[key] = dict
		masterAlbum = self.getAlbum([self.strMasterAlbum])
		masterAlbum['KeyList'].append(key)
		roll = self.getAlbum([self.strLatestRoll])
		roll['KeyList'].append(key)
		albums.append(masterAlbum['AlbumName'])
		albums.append(roll['AlbumName'])
		
		# get album, create if necessary
		print "addPhotoToAlbum=",albumPath
		if albumPath:
			album = self.getAlbum(albumPath)
			if album != masterAlbum:
				if not album:
					album = self.__newAlbumFromPath(albumPath)
					self.emit(PYSIGNAL("addAlbum"),(albumPath, None))
				album['KeyList'].append(key)
				albums.append(album['AlbumName'])
		
		return albums
		
	def __addPhotoEvent(self, e):
		(progress, total) = e.getProgress()
		key = e.getKey()
		if key:
			p = self.getImage(key)
			# ensure unique key
			key = self.__getNewKey(key)
			#add photo to 'Photo Library'
			albums = self.__addPhotoToAlbums(key, e.getDict(), e.getAlbumPath())
			self.emit(PYSIGNAL("importPhoto"),(albums, key, progress, total))
			self.fastWrite()
		else:
			# send an empty status eventAlbum 7
			self.emit(PYSIGNAL("importPhoto"),([], None, progress, total))

	def event(self, e):
		if e.type() == QEvent.User+1:
			self.__addPhotoEvent(e)
			return True
		elif e.type() == QEvent.User+2:
			print "import completed"
			source = e.getSource()
			self.emit(PYSIGNAL("importComplete"),(source, None))
			return True
		else:
			print "Non User Event Received",e.type()
			return False
			
	def importFromSource(self, source):
		# empty 'last roll' album
		lastRoll = self.getAlbum([self.strLatestRoll])
		lastRoll['KeyList'] = []
		self.emit(PYSIGNAL("updateAlbums"),([[self.strLatestRoll]],None))

		self.thread = LImportThread(self)
		self.thread.setImportObject(source)
		self.thread.start()
		
	def __deleteLinks(self, dir):
		if os.path.isdir(str(dir)):
			files = os.listdir(dir)
			for file in files:
				path = os.path.join(dir, file)
				print path
				if not os.path.isdir(path) and os.path.islink(path):
					os.remove(path)
		
	def __copyAlbumFilesRecurse(self, albumPath, dir):
		LUtils.ensureDirectory(str(dir))
		keys = self.getAlbum(albumPath)['KeyList']
		for key in keys:
			# create link to real file
			dict = self.getImage(key)
			(p, filename) = os.path.split(dict['ImagePath'])
			linkPath = os.path.join(str(dir), filename)
			shutil.copy2(dict['ImagePath'], linkPath)
		albums = self.getAlbum(albumPath)['AlbumList']
		for album in albums:
			newDir = os.path.join(str(dir), album['AlbumName'])
			self.__copyAlbumFilesRecurse(albumPath + [album['AlbumName']], newDir)
		return dir

	def __createAlbumLinksRecurse(self, albumPath):
		dir = self.getAlbumFilesystemPath(albumPath)
		LUtils.ensureDirectory(str(dir))
		self.__deleteLinks(str(dir))
		keys = self.getAlbum(albumPath)['KeyList']
		for key in keys:
			# create link to real file
			dict = self.getImage(key)
			(p, filename) = os.path.split(dict['ImagePath'])
			linkPath = os.path.join(dir, filename)
			os.symlink(dict['ImagePath'], linkPath)
		albums = self.getAlbum(albumPath)['AlbumList']
		for album in albums:
			self.__createAlbumLinksRecurse(albumPath + [album['AlbumName']])
		return dir
		
	def exportAlbumToFolder(self, albumPath, dir):
		self.__copyAlbumFilesRecurse(albumPath, dir)
		
	def exportKeysToFolder(self, keys, dir):
		LUtils.ensureDirectory(str(dir))
		for key in keys:
			# create link to real file
			dict = self.getImage(key)
			(p, filename) = os.path.split(dict['ImagePath'])
			linkPath = os.path.join(str(dir), filename)
			shutil.copy2(dict['ImagePath'], linkPath)
		
	def moveAlbum(self, dstPath, srcPath):
		# find dst album
		if len(srcPath) == 0:
			print "empty src album!"
			return
			
		if LUtils.isListChild(srcPath, dstPath):
			return 
	
		if len(dstPath) == 0:
			dst = self.rootPList[0]['List of Albums']
		else: 
			dst = self.getAlbum(dstPath)['AlbumList']
		if dst != None:
			# check for album with the same name
			name = srcPath[len(srcPath)-1]
			newPath = dstPath[0:len(dstPath)]
			newPath.append(name)
			for n in dst:
				if n['AlbumName'] == name:
					self.emit(PYSIGNAL("error"), ("An album named '"+str(name)+"' already exists.", None))
					return
			srcAlbum = self.removeAlbum(srcPath)
			if srcAlbum:
				dst.append(srcAlbum)
				# move filesystem folder
				self.emit(PYSIGNAL("moveAlbum"), (newPath, srcPath))
				
	def __backupImage(self, photo, restore=False):
		ipath = photo['ImagePath']
		(dir, filename) = os.path.split(ipath)
		bdir = os.path.join(dir,"originals")
		bpath = os.path.join(bdir,filename)
		if restore:
			if LUtils.fileExists(bpath):
				shutil.move(bpath, ipath)
		else:
			if not(LUtils.fileExists(bpath)):
				LUtils.ensureDirectory(bdir)
				shutil.copy2(ipath, bpath)

	def rotateImage(self, key):
		wc = LWaitCursor()
		photo = self.getImage(key)
		self.__backupImage(photo)
		ipath = photo['ImagePath']
		os.system("jpegtran -copy all -rotate 90 -outfile \"%s\" \"%s\"" % (ipath,ipath))
		self.__refreshThumbnail(photo)
		self.emit(PYSIGNAL("updateImage"), (key, None))
		self.fastWrite()

	def rotateCCImage(self, key):
		wc = LWaitCursor()
		photo = self.getImage(key)
		self.__backupImage(photo)
		ipath = photo['ImagePath']
		os.system("jpegtran -copy all -rotate 270 -outfile \"%s\" \"%s\"" % (ipath,ipath))
		self.__refreshThumbnail(photo)
		self.emit(PYSIGNAL("updateImage"), (key, None))
		self.fastWrite()

	def cropImage(self, key, rect):
		wc = LWaitCursor()
		photo = self.getImage(key)
		self.__backupImage(photo)
		ipath = photo['ImagePath']
		os.system("jpegtran -copy all -crop %dx%d+%d+%d -outfile \"%s\" \"%s\"" % (rect.width(),rect.height(),rect.left(),rect.top(),ipath,ipath))
		self.__refreshThumbnail(photo)
		self.emit(PYSIGNAL("updateImage"), (key, None))
		self.fastWrite()

	def greyScaleImage(self, key):
		wc = LWaitCursor()
		photo = self.getImage(key)
		self.__backupImage(photo)
		ipath =photo['ImagePath']
		os.system("jpegtran -copy all -grayscale -outfile \"%s\" \"%s\"" % (ipath,ipath))
		self.__refreshThumbnail(photo)
		self.emit(PYSIGNAL("updateImageDetail"), (key, None))
	
	def redeyeImage(self, key, rect):
		wc = LWaitCursor()
		# load rect from file into QImage
		photo = self.getImage(key)
		self.__backupImage(photo)
		ipath = photo['ImagePath']
		i = QImage(ipath)
		tempFile = "temp.jpg"
		if i:
			for x in range(rect.left(),rect.right()):
				for y in range(rect.top(),rect.bottom()):
					rgb = i.pixel(x,y)
					r = qRed(rgb)#.0/255.0
					g = qGreen(rgb)#/255.0
					b = qBlue(rgb)#/255.0
					if r:
						redness = (4.0-(4.0*max(g,b))/r)
						if redness < 0:
							redness = 0
						else:
							#redness = redness * redness / 16.0 * 255.0
							if redness > 0.7921:
								r = max(g,b)
								rgb = qRgb(r,g,b)
								i.setPixel(x,y,rgb)
##~ 					else:
##~ 						redness = 0
##~ 				
##~ 					rgb = qRgb(redness,redness,redness)
##~ 					i.setPixel(x,y,rgb)
##~ 					if qRed(rgb)>1.5*qGreen(rgb) and qRed(rgb)>1.5*qBlue(rgb):
##~ 						rgb = qRgb(qBlue(rgb),qGreen(rgb),qBlue(rgb))
##~ 						i.setPixel(x,y,rgb)
			i.save(ipath, "JPEG", 100)
##~ 			red.save(tempFile, "JPEG", 100)
##~ 			os.system("jpegtran -copy all -drop +%d+%d \"%s\" -outfile \"%s\" \"%s\"" % (rect.x(),rect.y(),tempFile,ipath,ipath))
			self.__refreshThumbnail(photo)
			self.emit(PYSIGNAL("updateImageDetail"), (key, None))
			
	def revertImage(self, key):
		wc = LWaitCursor()
		photo = self.getImage(key)
		self.__backupImage(photo, True)
		self.__refreshThumbnail(photo)
		self.emit(PYSIGNAL("updateImage"), (key, None))
		
	def enhanceImage(self, key):
		wc = LWaitCursor()
		photo = self.getImage(key)
		self.__backupImage(photo)
		ipath =photo['ImagePath']
		os.system("convert -normalize \"%s\" \"%s\"" % (ipath,ipath))
		self.__refreshThumbnail(photo)
		self.emit(PYSIGNAL("updateImageDetail"), (key, None))
			
	def dateSwap(self, key):
		dict = self.getImage(key)
		if dict:
			o = dict['Date']
			n = dict['ImportDate']
			dict['ImportDate'] = o
			dict['Date'] = n
			print "old",o,"new",n
			
		self.emit(PYSIGNAL("updateImage"), (key, None))
			
	def __xmlAtom(self,doc,parent,tag,text):
		obj = doc.createElement(tag)
		parent.appendChild(obj)
		obj.appendChild(doc.createTextNode(str(text)))
		
	def getXMLFromKeys(self, keys, wrapper="Thumbs", title="My Photos"):
		doc = QDomDocument(wrapper)
		root = doc.createElement(wrapper)
		root.setAttribute('version','1.0')
		root.setAttribute('Title',title)
		doc.appendChild(root)
		for key in keys:
			dict = self.getImage(key)
			if dict:
				element = doc.createElement('Photo')
				root.appendChild(element)
				(path, filename) = os.path.split(dict['ImagePath'])
				self.__xmlAtom(doc, element, "Filename", filename)
				self.__xmlAtom(doc, element, "Title", dict.get('Caption'))
				self.__xmlAtom(doc, element, "Rating", dict.get('Rating'))
				self.__xmlAtom(doc, element, "Comments", dict.get('Comments'))
		return str(doc.toString())
		
	def __funcClearScreensaver(self, album):
		album['Screensaver']=False
		
	def __recurseAlbums(self, func, albums = None):
		if albums == None:
			albums = self.rootPList[0]['List of Albums']
		for album in albums:
			func(album)
			childList = album['AlbumList']
			if childList and len(childList):
				self.__recurseAlbums(func, childList)
				
	def __writeTextFile(self, path, lines):
		f = open(path, "w")
		f.writelines(lines)
		f.close()
				
	def __modifyConfigFile(self, path, section, name, value):
		sectionPattern = re.compile(r"\[(.*)\]")
		namePattern = re.compile(r"^([^ ]*) *= *(.*)$")
		lines = []
		try:
			f = open(path,"r")
			lines = f.readlines()
			f.close()
			curSection = None
		except:
			pass
		
		for i in xrange(len(lines)):
			mc = sectionPattern.match(lines[i])
			if mc:
				if curSection == section:
					# we got to the end of the section without finding the line.  Add it here
					lines.insert(i, "%s=%s\n"%(name,value))
					self.__writeTextFile(path, lines)
					return
				else:
					curSection = mc.group(1)
			elif section == curSection:
				print lines[i]
				mc = namePattern.match(lines[i])
				if mc and mc.group(1) == name:
					lines[i] = "%s=%s\n"%(name,value)
					self.__writeTextFile(path, lines)
					return
		# if we got here then the section wasn't found
		if section:	# don't write 'None' section
			lines.append("[%s]\n"%(section))
		lines.append("%s=%s\n"%(name,value))
		self.__writeTextFile(path, lines)
		
	def __hasOpenGL(self):
		try:
			text = backtick("glxinfo | grep \"direct rendering\"")
			regex = re.compile(r"Yes")
			mc = regex.search(text)
			if mc:
				return True
		except:
			return True
		return False
	
	def setScreensaverAlbum(self, albumPath):
		# mark album properties
		if self.__hasOpenGL():
			configFile = "kslidesaverglrc"
			section = None
			name = "imageDirectory"
			cmd = "kslidesavergl.desktop"
			print "hadGL"
		else:
			configFile = "kslideshow.kssrc"
			section = "Settings"
			name = "Directory"
			cmd = "KSlideshow.desktop"
			print "noGL"
		album = self.getAlbum(albumPath)
		if album:
			func = self.__funcClearScreensaver
			func(x)
			func.attr = "test"
			self.__recurseAlbums(self.__funcClearScreensaver)
			album['Screensaver']=True # unmark all other screensaver albums here!
			dir = str(self.__createAlbumLinksRecurse(albumPath))
			# create ~/.kde/share/config/lphoto
			# imageDirectory = $dir
			sConfigPath = str(os.path.join(os.path.expanduser('~'),".kde","share","config",configFile))
			dConfigPath = str(os.path.join(os.path.expanduser('~'),".kde","share","config","kdesktoprc"))
			self.__modifyConfigFile(sConfigPath, section, name, dir)
			self.__modifyConfigFile(dConfigPath, "ScreenSaver", "Saver", cmd)
			self.__modifyConfigFile(dConfigPath, "ScreenSaver", "Enabled", "true")
			os.system("dcop kdesktop KScreensaverIface enable true")
			
	def reorderAlbumKeys(self, albumPath, key, keys):
		album = self.getAlbum(albumPath)
		if key in keys:
			return
		if not(album):
			return
		albumKeys = album['KeyList']
		if key == None:
			self.trashKeyListFromAlbum(album, keys)
			albumKeys.extend(keys)
		else:
			self.trashKeyListFromAlbum(album, keys)
			
			i = albumKeys.index(key)
			a = albumKeys[:i]
			b = albumKeys[i:]
			a.extend(keys)
			a.extend(b)
			album['KeyList'] = a
			
	def getAlbumFilesystemPath(self, albumPath):
		dir = os.path.join(LPhotoLibrary.libraryPath(),"albums")
		for d in albumPath:
			dir = os.path.join(str(dir), str(d))
		return dir
		
	def slotDragSourceImport(self, files):
		# create new album 
		album = self.__newAlbum(self.__getNewAlbumName(), [])
		albumPath = [album['AlbumName']]
		self.rootPList[0]['List of Albums'].append(album)
		self.emit(PYSIGNAL("addAlbum"),(album['AlbumName'], None))
		source = LDragImport(files, albumPath)
		self.emit(PYSIGNAL("dragImport"), (source, None))
		
	def slotDuplicate(self, key, albumPath):
		print "duplicate"
		sc = LWaitCursor()
		# get new key
		newKey = self.__getNewKey(key)
		#duplicate current imageself.getImage(key)
		orig = self.getImage(key)
		dict = copy.deepcopy(orig)
		dir, filename = os.path.split(dict['ImagePath'])
		filename = LUtils.findUniqueFilename(dir, filename)
		print "duplicating", filename
		dict['ImagePath'] = str(os.path.join(dir, filename))
		dict['ThumbPath'] = str(os.path.join(dir, "Thumbs", filename))
		shutil.copy2(orig['ImagePath'], dict['ImagePath'])
		(w,h) = LUtils.downsizeImage(dict['ImagePath'], dict['ThumbPath'])
		if h==0 or w==0:
			return # no width or height
			
		dict['AspectRatio'] = w/float(h)#LUtils.createThumbnail(photo['ImagePath'], photo['ThumbPath'])
		dict['Width'] = w
		dict['Height'] = h
		albums = self.__addPhotoToAlbums(newKey, dict, albumPath)
		self.emit(PYSIGNAL("updateAlbums"),([albumPath],None))
	
			
			
		
