<?xml version="1.0" encoding="iso-8859-1"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns="http://www.w3.org/1999/xhtml" version="1.0">
<xsl:output encoding="iso-8859-1" method="xml" doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN" doctype-system="DTD/xhtml1-strict.dtd"/>


<xsl:template match="/Thumbs">
<html>
<head>
<title><xsl:value-of select="@Title"/></title>
<style>
BODY {background-color:#CCE; }
TD.fulltablecolumn { font-family:Verdana,Helvetica,sans; font-size:12px; vertical-align:top; horizontal-align:center; }
IMG { border:solid white 5px; }
H1 { font-family:Verdana,Helvetica,sans; font-weight:bold; font-size:25px; text-align: center;}
TABLE.phototable { border: groove blue 2px; margin-left:auto; margin-right:auto;}
TR.phototablephotorow { background-color: white;}
TD.phototabledescriptioncolumn {background-color:#88C; text-align:center;}
SPAN.phototitle {font-size: 14px; font-weight:bold; text-align:center;}
SPAN.photodescription { text-align:center; }
</style>
</head>
<body>

<table class="fulltable">
<tr><td colspan="5"><h1><xsl:value-of select="@Title"/></h1></td></tr>
<xsl:apply-templates/>
</table>
</body>
</html>
</xsl:template>
<xsl:template match="/Thumbs/Photo">
<xsl:if test="(position() mod 10) = 2">
	<xsl:text disable-output-escaping="yes">&lt;tr class="fulltablerow" &gt;</xsl:text>
</xsl:if>
<td width="1" class="fulltablecolumn">
	<table class="phototable">
		<tr class="phototablephotorow">
			<td class="phototablephotocolumn">
				<a>
					<xsl:attribute name="href">p_<xsl:value-of select="Filename"/>.html</xsl:attribute>
					<img>
						<xsl:attribute name="src">thumbs/<xsl:value-of select="Filename"/></xsl:attribute>
					</img><br/>
				</a>
			</td>
		</tr>
		<tr class="phototabledescriptionrow">
			<td class="phototabledescriptioncolumn">
				<span class="phototitle"><xsl:value-of select="Title"/></span>
				<xsl:if test="./Comments != 'None'">
					<br/><span class="photodescription"><xsl:value-of select="Comments"/></span>
				</xsl:if>
			</td>
		</tr>
	</table>
</td>
<xsl:if test="(position() mod 10) = 0">
	<xsl:text disable-output-escaping="yes">&lt;/tr&gt;</xsl:text>
</xsl:if>
</xsl:template>

<xsl:template match="/Photo">
<html>
<head>
<title><xsl:value-of select="@Caption"/></title>
<style>
BODY {background-color:#CCE; }
IMG { border:solid white 5px; }
SPAN.phototitle {font-family:Verdana,Helvetica,sans; font-size: 18px; font-weight:bold; text-align:center;}
SPAN.photodescription { font-family:Verdana,Helvetica,sans; text-align:center; }
TD.phototext {background-color:#88C; text-align:center;}
</style>
</head>
<body>
<table border="1">
<xsl:apply-templates/>
</table>
</body>
</html>
</xsl:template>

<xsl:template match="/Photo/Photo">
<tr>
	<td>
		<img>
			<xsl:attribute name="src">images/<xsl:value-of select="Filename"/></xsl:attribute>
		</img>
	</td>
</tr>
<tr>
	<td class="phototext">
		<span class="phototitle"><xsl:value-of select="Title"/></span>
		<xsl:if test="./Comments != 'None'">
			<br/>
			<span class="photodescription"><xsl:value-of select="Comments"/></span>
		</xsl:if>
	</td>
</tr>
</xsl:template>
</xsl:stylesheet>

